package cn.dg32z.lon.manager.logs.dao;

import cn.dg32z.libs.chengzhiya.task.mhdfscheduler.scheduler.MHDFScheduler;
import cn.dg32z.libs.com.j256.ormlite.dao.Dao;
import cn.dg32z.libs.com.j256.ormlite.dao.DaoManager;
import cn.dg32z.libs.com.j256.ormlite.stmt.DeleteBuilder;
import cn.dg32z.libs.com.j256.ormlite.stmt.QueryBuilder;
import cn.dg32z.libs.com.j256.ormlite.support.ConnectionSource;
import cn.dg32z.lon.LonAntiCheat;
import cn.dg32z.lon.PluginLoader;
import cn.dg32z.lon.manager.logs.entity.Violation;
import cn.dg32z.lon.manager.logs.interfaces.ViolationManager;
import cn.dg32z.lon.manager.plugin.init.HookInit;
import cn.dg32z.lon.player.PlayerData;
import java.sql.SQLException;
import java.util.List;
import org.bukkit.OfflinePlayer;

/* loaded from: cn_dg32z_lon_manager_logs_dao.jar:cn/dg32z/lon/manager/logs/dao/ViolationOrmLiteUtil.class */
public final class ViolationOrmLiteUtil implements ViolationManager {
    private final Dao<Violation, Integer> dao;

    public ViolationOrmLiteUtil(ConnectionSource connectionSource) {
        try {
            this.dao = DaoManager.createDao(connectionSource, Violation.class);
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
    }

    public void logAlertSync(OfflinePlayer offlinePlayer, PlayerData player, boolean exp, String verbose, String checkName, int violations, String description, String ping, boolean lagging, boolean moveLagging, String tps, String brand, String version) {
        String dataType = PluginLoader.INSTANCE.getConfigManager().getConfig().getString("database-manager.data-type");
        Violation entity = new Violation(HookInit.getPlaceholderAPIHook().setPlaceholders(offlinePlayer, PluginLoader.INSTANCE.getMessageUtils().i18nWithOutPrefix("database-manager.server-name")), player.getUniqueId(), player.getName(), checkName, verbose, violations, description, exp, System.currentTimeMillis(), ping, lagging, moveLagging, tps, brand, version);
        if (dataType == null || dataType.equalsIgnoreCase("sqlite")) {
            try {
                this.dao.createOrUpdate(entity);
                return;
            } catch (Exception ex) {
                throw new RuntimeException("ORMLite 插入 Violation 失败", ex);
            }
        }
        MHDFScheduler.getAsyncScheduler().runTask(LonAntiCheat.getInstance(), task -> {
            try {
                this.dao.createOrUpdate(entity);
            } catch (Exception ex2) {
                throw new RuntimeException("ORMLite 插入 Violation 失败", ex2);
            }
        });
    }

    public long getLogCount(OfflinePlayer player) {
        try {
            return this.dao.queryBuilder().setCountOf(true).where().eq("uuid", player.getUniqueId()).countOf();
        } catch (Exception ex) {
            throw new RuntimeException("ORMLite 查询Violation数量失败", ex);
        }
    }

    public List<Violation> getViolations(OfflinePlayer player, int page, int limit) {
        try {
            QueryBuilder<Violation, Integer> qb = this.dao.queryBuilder();
            qb.orderBy("created_at", false);
            qb.where().eq("uuid", player.getUniqueId());
            qb.offset(Long.valueOf((page - 1) * limit)).limit(Long.valueOf(limit));
            return qb.query();
        } catch (Exception ex) {
            throw new RuntimeException("ORMLite 查询Violation失败", ex);
        }
    }

    public void clearLogs(OfflinePlayer player) {
        MHDFScheduler.getAsyncScheduler().runTask(LonAntiCheat.getInstance(), task -> {
            try {
                DeleteBuilder<Violation, Integer> db = this.dao.deleteBuilder();
                db.where().eq("uuid", player.getUniqueId());
                db.delete();
            } catch (Exception ex) {
                throw new RuntimeException("ORMLite 清除指定玩家日志失败", ex);
            }
        });
    }

    public void clearAllLogs() {
        MHDFScheduler.getAsyncScheduler().runTask(LonAntiCheat.getInstance(), task -> {
            try {
                this.dao.deleteBuilder().delete();
            } catch (Exception ex) {
                throw new RuntimeException("ORMLite 清除全部日志失败", ex);
            }
        });
    }
}
